"""autogenerated by genpy from epos_driver/EPOSState.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class EPOSState(genpy.Message):
  _md5sum = "bd7e8496790385978d37612e81cd065e"
  _type = "epos_driver/EPOSState"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This is a file in which the message publishing epos state is
# defined. It should return thesame types of inrmation as the Player
# driver.  
Header header        #standard header information

int64 raw_position   # position directly from readActualPosition
float64 position     # position in radians (I hope)

int64 raw_speed      # speed directly from readActualSpeed
float64 speed        # speed in radians (I hope)

float64 acceleration # computed acceleration
int16 current        # current directly from readActualCurrent

bool sync            # change to true if servo is not moving
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','raw_position','position','raw_speed','speed','acceleration','current','sync']
  _slot_types = ['std_msgs/Header','int64','float64','int64','float64','float64','int16','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,raw_position,position,raw_speed,speed,acceleration,current,sync

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EPOSState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.raw_position is None:
        self.raw_position = 0
      if self.position is None:
        self.position = 0.
      if self.raw_speed is None:
        self.raw_speed = 0
      if self.speed is None:
        self.speed = 0.
      if self.acceleration is None:
        self.acceleration = 0.
      if self.current is None:
        self.current = 0
      if self.sync is None:
        self.sync = False
    else:
      self.header = std_msgs.msg.Header()
      self.raw_position = 0
      self.position = 0.
      self.raw_speed = 0
      self.speed = 0.
      self.acceleration = 0.
      self.current = 0
      self.sync = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_qdq2dhB.pack(_x.raw_position, _x.position, _x.raw_speed, _x.speed, _x.acceleration, _x.current, _x.sync))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 43
      (_x.raw_position, _x.position, _x.raw_speed, _x.speed, _x.acceleration, _x.current, _x.sync,) = _struct_qdq2dhB.unpack(str[start:end])
      self.sync = bool(self.sync)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_qdq2dhB.pack(_x.raw_position, _x.position, _x.raw_speed, _x.speed, _x.acceleration, _x.current, _x.sync))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 43
      (_x.raw_position, _x.position, _x.raw_speed, _x.speed, _x.acceleration, _x.current, _x.sync,) = _struct_qdq2dhB.unpack(str[start:end])
      self.sync = bool(self.sync)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_qdq2dhB = struct.Struct("<qdq2dhB")
